using System;
using System.Runtime.InteropServices;
using System.Drawing.Imaging;
using System.Drawing;
using System.IO;

namespace ScreenShot
{

	 /// <summary>
	 ///     
	 /// </summary>
	 public class ScreenShotDll
	 {
		 /// <summary>
		 /// 
		 /// </summary>
		 /// <param name="fileName"> .</param>
		 /// <param name="imageFormat"> .</param>
		 public void CaptureScreen(string fileName,ImageFormat imageFormat)
		 {
			 int hdcSrc = User32.GetWindowDC(User32.GetDesktopWindow()), 
				 hdcDest = GDI32.CreateCompatibleDC(hdcSrc),
				 hBitmap = GDI32.CreateCompatibleBitmap(hdcSrc,
				 GDI32.GetDeviceCaps(hdcSrc,8),GDI32.GetDeviceCaps(hdcSrc,10)); 
			 GDI32.SelectObject(hdcDest,hBitmap);
			 GDI32.BitBlt(hdcDest,0,0,GDI32.GetDeviceCaps(hdcSrc,8),
				 GDI32.GetDeviceCaps(hdcSrc,10),
				 hdcSrc,0,0,0x00CC0020);
			 SaveImageAs(hBitmap,fileName,imageFormat);
			 Cleanup(hBitmap,hdcSrc,hdcDest);
		 }
		 /// <summary>
		 ///     Windows Bitmap
		 /// </summary>
		 /// <returns></returns>
		 public Bitmap CaptureScreen()
		 {
			 int hdcSrc = User32.GetWindowDC(User32.GetDesktopWindow()), 
				 hdcDest = GDI32.CreateCompatibleDC(hdcSrc),
				 hBitmap = GDI32.CreateCompatibleBitmap(hdcSrc,
				 GDI32.GetDeviceCaps(hdcSrc,8),GDI32.GetDeviceCaps(hdcSrc,10)); 
			 GDI32.SelectObject(hdcDest,hBitmap);
			 GDI32.BitBlt(hdcDest,0,0,GDI32.GetDeviceCaps(hdcSrc,8),
				 GDI32.GetDeviceCaps(hdcSrc,10),
				 hdcSrc,0,0,0x00CC0020);
			 Bitmap btm = GetImage(hBitmap);
			 Cleanup(hBitmap,hdcSrc,hdcDest);
			 return btm;
		 }
		 /// <summary>
		 ///   .
		 /// </summary>
		 /// <param name="hBitmap">   .</param>
		 /// <param name="hdcSrc">    .</param>
		 /// <param name="hdcDest">    .</param>
		 private void Cleanup(int hBitmap, int hdcSrc, int hdcDest)
		 {
			 User32.ReleaseDC(User32.GetDesktopWindow(),hdcSrc);
			 GDI32.DeleteDC(hdcDest);
			 GDI32.DeleteObject(hBitmap);
		 }      
		 /// <summary>
		 ///  
		 /// </summary>
		 /// <param name="hBitmap">  .</param>
		 /// <param name="fileName"> .</param>
		 /// <param name="imageFormat"> .</param>
		 private void SaveImageAs(int hBitmap, string fileName, ImageFormat imageFormat)
		 {
			 Bitmap image = new Bitmap(Image.FromHbitmap(new IntPtr(hBitmap)),
				 Image.FromHbitmap(new IntPtr(hBitmap)).Width,
				 Image.FromHbitmap(new IntPtr(hBitmap)).Height);
			 image.Save(fileName,imageFormat);
		 }
		 /// <summary>
		 ///     .
		 /// </summary>
		 /// <param name="hBitmap">  .</param>
		 /// <returns></returns>
		 private Bitmap GetImage(int hBitmap)
		 {
			 Bitmap image = 
				 new Bitmap(Image.FromHbitmap(new IntPtr(hBitmap)),
				 Image.FromHbitmap(new IntPtr(hBitmap)).Width,
				 Image.FromHbitmap(new IntPtr(hBitmap)).Height);
			 return image;
		 }
	 }
	 /// <summary>
	 ///    User32
	 /// </summary>
	 class User32
	 {
		 /// <summary>
		 ///      .
		 /// </summary>
		 /// <returns></returns>
		 [DllImport("User32.dll")]
		 public static extern int GetDesktopWindow();
		 /// <summary>
		 ///   .
		 /// </summary>
		 /// <param name="hWnd">  .</param>
		 /// <returns></returns>
		 [DllImport("User32.dll")]
		 public static extern int GetWindowDC(int hWnd);
		 /// <summary>
		 ///    .
		 /// </summary>
		 /// <param name="hWnd">  .</param>
		 /// <param name="hDC">   .</param>
		 /// <returns></returns>
		 [DllImport("User32.dll")]
		 public static extern int ReleaseDC(int hWnd,int hDC);
	 }
	 /// <summary>
	 ///    GDI32
	 /// </summary>
	 class GDI32
	 {
		 /// <summary>
		 ///  .
		 /// </summary>
		 /// <param name="hdcDest">   .</param>
		 /// <param name="nXDest">     .</param>
		 /// <param name="nYDest">     .</param>
		 /// <param name="nWidth"> .</param>
		 /// <param name="nHeight"> .</param>
		 /// <param name="hdcSrc">  .</param>
		 /// <param name="nXSrc">     .</param>
		 /// <param name="nYSrc">     .</param>
		 /// <param name="dwRop">  .</param>
		 /// <returns></returns>
		 [DllImport("GDI32.dll")]
		 public static extern bool BitBlt(int hdcDest, int nXDest, int nYDest, int nWidth, int nHeight, int hdcSrc, 
			 int nXSrc, int nYSrc,int dwRop);
		 /// <summary>
		 ///        .
		 /// </summary>
		 /// <param name="hdc">   .</param>
		 /// <param name="nWidth"> .</param>
		 /// <param name="nHeight"> .</param>
		 /// <returns></returns>
		 [DllImport("GDI32.dll")]
		 public static extern int CreateCompatibleBitmap(int hdc,int nWidth, int nHeight);
		 /// <summary>
		 ///        ,     .
		 ///        
		 ///   ,       . 
		 ///       CreateCompatibleBitmap,     . 
		 ///         GetDeviceCaps. 
		  ///           DeleteDC.
		 /// </summary>
		 /// <param name="hdc">    .    null,
		 ///         .</param>
		 /// <returns></returns>
		 [DllImport("GDI32.dll")]
		 public static extern int CreateCompatibleDC(int hdc);
		 /// <summary>
		 ///     .
		 /// </summary>
		 /// <param name="hdc"> .</param>
		 /// <returns></returns>
		 [DllImport("GDI32.dll")]
		 public static extern bool DeleteDC(int hdc);
		 /// <summary>
		 ///      .
		 /// </summary>
		 /// <param name="hObject">   .</param>
		 /// <returns></returns>
		 [DllImport("GDI32.dll")]
		 public static extern bool DeleteObject(int hObject);
		 /// <summary>
		 ///      .
		 /// </summary>
		 /// <param name="hdc">   .</param>
		 /// <param name="nIndex"> . .</param>
		 /// <returns></returns>
		 [DllImport("GDI32.dll")]
		 public static extern int GetDeviceCaps(int hdc, int nIndex);
		 /// <summary>
		 ///  ,     .
		 /// </summary>
		 /// <param name="hdc">   .</param>
		 /// <param name="hgdiobj">  .</param>
		 /// <returns></returns>
		 [DllImport("GDI32.dll")]
		 public static extern int SelectObject(int hdc, int hgdiobj);
	 }
 }


